# -*- coding: utf8 -*-

#-----------------------------------------
# This is a part of Collège 3D project.
# Author:       Pascal Peter
# Copyright:    (C) 2003-2016 Pascal Peter
# Licence:      GNU General Public Licence version 3
# Website:      http://pascal.peter.free.fr/
# Email:        pascal.peter at free.fr
#-----------------------------------------

"""
DESCRIPTION :
    Écran perdu puis retour au menu.
"""

# **************************************************
#       IMPORTATION DES MODULES UTILES
# **************************************************
from time import time

import bge

import utils, input_controller



# **************************************************
#       CONTRÔLES DU JEU
# **************************************************
scene = None



# **************************************************
#       FONCTIONS UTILES
# **************************************************
def postDrawTexts():
    """
    affichage des textes.
    """
    utils.postDrawTexts('gameover_loop')



# **************************************************
#       FONCTION PRINCIPALE
# **************************************************
def main():
    # ---------------------------------------------------------
    # RÉCUPÉRATION DE L'ÉTAT DU JEU
    # ---------------------------------------------------------
    state = bge.logic.globalDict['GAME'].get('state', '')
    if not(state in ('gameover_first', 'gameover_loop')):
        bge.logic.globalDict['GAME']['state'] = 'gameover_first'

    # ---------------------------------------------------------
    # PREMIER LANCEMENT
    # ---------------------------------------------------------
    if bge.logic.globalDict['GAME']['state'] == 'gameover_first':
        # on masque la souris :
        bge.render.showMouse(False)
        # valeurs initiales (lues depuis le fichier de config si existe) :
        utils.loadSettings()
        lang = bge.logic.globalDict['MENU']['lang']
        # affichage des textes :
        global scene
        scene = bge.logic.getCurrentScene()
        scene.post_draw += [postDrawTexts]
        bge.logic.globalDict['TEXTS'] = {}
        # initialisation des timers :
        bge.logic.globalDict['TEMP']['initialTime'] = time()
        bge.logic.globalDict['TEMP']['actualTime'] = 0
        bge.logic.globalDict['TEMP']['timeSpecific'] = {1: False, 2: False, 5: False}
        # initialisation terminée :
        bge.logic.globalDict['GAME']['state'] = 'gameover_loop'

    # ---------------------------------------------------------
    # BOUCLE DES ÉVÉNEMENTS
    # ---------------------------------------------------------
    if bge.logic.globalDict['GAME']['state'] != 'gameover_loop':
        return
    inputState = input_controller.inputManagement('splash')
    # pour faire un screencast :
    if inputState['SCREENSHOT']:
        utils.makeScreenshot()
    actualTime = int(round(time() - bge.logic.globalDict['TEMP']['initialTime']))
    if actualTime > bge.logic.globalDict['TEMP']['actualTime']:
        bge.logic.globalDict['TEMP']['actualTime'] = actualTime
        for i in bge.logic.globalDict['TEMP']['timeSpecific']:
            if (actualTime >= i) and not(bge.logic.globalDict['TEMP']['timeSpecific'][i]):
                bge.logic.globalDict['TEMP']['timeSpecific'][i] = True
                if i == 1:
                    utils.setText(
                        'progName', text=utils.PROGNAME, 
                        color=utils.colors['orange'], width=9, position=(0.15, 0.25))
                elif i == 2:
                    lang = bge.logic.globalDict['MENU']['lang']
                    text = utils.tr('other', 'GAME OVER', lang)
                    utils.setText(
                        'message', text=text, 
                        color=utils.colors['white'], width=5, position=(0.18, 0.7))
                elif i == 5:
                    scene.replace('levels')


